c============================================= First hyperpolarizability
c================================================ beta_xab(-w1-w2;w1,w2)

      SUBROUTINE calc_beta( n, a,b, n1,n2, hw1,hw2 )
      use hyp_data
      implicit none

      integer,intent(IN)  :: n,a,b,n1,n2
      real(8),intent(IN)  :: hw1,hw2
      real(8),allocatable :: trD(:),BB(:)

      allocate( trD(ML),BB(ML) )

      write(*,'(/1x,"----- beta(",i1,")_x",2i1," -----")') n,a,b

! beta ( free )

      write(*,'(/1x,"(Free)")')

      iterCG=0

c chi1

      call calc_chi1( trD, Gxc*dn1(:,a,n1)*dn1(:,b,n2), hw1+hw2 )

c chi2

      call calc_chi2( BB, h1(:,a,n1), h1(:,b,n2), hw1,hw2 )
      trD=trD+BB
      if ( b==a .and. n2==n1 ) then
         trD=trD+BB
      else
         call calc_chi2( BB, h1(:,b,n2), h1(:,a,n1), hw2,hw1 )
         trD=trD+BB
      end if

      betaF(:,a,b,n)=const*matmul( trD,D )*H**3

      write(*,'(3(/1x,"betaF_",3i1," =",g24.15))')
     &     1,a,b, betaF(1,a,b,n)
     &    ,2,a,b, betaF(2,a,b,n)
     &    ,3,a,b, betaF(3,a,b,n)

      write(*,'(/1x,"C-G iteration =",i5)') iterCG

! beta

      write(*,'(/1x,"(RPA)")')

      dn2(:,a,b,n)
     &            =0.d0       ! initial guess 1
!     &            =trD        ! initial guess 2

      call ConjResidu( dn2(:,a,b,n), trD, hw1+hw2 )

      beta(:,a,b,n)=const*matmul( dn2(:,a,b,n),D )*H**3

      write(*,'(3(/1x,"beta_",3i1," =",g24.15))')
     &     1,a,b, beta(1,a,b,n)
     &    ,2,a,b, beta(2,a,b,n)
     &    ,3,a,b, beta(3,a,b,n)

      h2(:,a,b,n)=0.d0 ; call Hartree(dn2(:,a,b,n),h2(:,a,b,n),Hconv)
      h2(:,a,b,n) = h2(:,a,b,n)
     &            + Fxc*dn2(:,a,b,n) + Gxc*dn1(:,a,n1)*dn1(:,b,n2)

      deallocate( trD, BB )

      return

      END SUBROUTINE calc_beta
