c============================================= First hyperpolarizability
c================================================ beta_xab(-w1-w2;w1,w2)

      SUBROUTINE calc_beta( n, a,b, n1,n2, hw1,hw2 )
      use chyp_data
      implicit none

      integer,intent(IN)  :: n,a,b,n1,n2
      complex(8),intent(IN)  :: hw1,hw2
      complex(8),allocatable :: trD(:),BB(:)

      allocate( trD(ML),BB(ML) )

      write(*,'(/1x,"----- beta(",i1,")_x",2i1," -----")') n,a,b

! beta ( free )

      write(*,'(/1x,"(Free)")')

      iterCG=0

c chi1

!      call calc_chi1( trD, Gxc*dn1(:,a,n1)*dn1(:,b,n2), hw1+hw2 )
      trD=(0.d0,0.d0)

c chi2

      call calc_chi2( BB, h1(:,a,n1), h1(:,b,n2), hw1,hw2 )
      trD=trD+BB
      if ( b==a .and. n2==n1 ) then
         trD=trD+BB
      else
         call calc_chi2( BB, h1(:,b,n2), h1(:,a,n1), hw2,hw1 )
         trD=trD+BB
      end if

      betaF(:,a,b,n)=const*matmul( trD,D )*H**3

      write(*,'(3(/1x,"betaF_",3i1," =",2g24.15))')
     &     1,a,b, real(betaF(1,a,b,n)), imag(betaF(1,a,b,n))
     &    ,2,a,b, real(betaF(2,a,b,n)), imag(betaF(2,a,b,n))
     &    ,3,a,b, real(betaF(3,a,b,n)), imag(betaF(3,a,b,n))

      write(*,'(/1x,"C-G iteration =",i5)') iterCG

! beta

      write(*,'(/1x,"(RPA)")')

! initial guess

!      dn2(:,a,b,n) = dn2(:,a,b,n) ( previous result )
!      dn2(:,a,b,n) = (0.d0,0.d0)
!      dn2(:,a,b,n) = trD

!      call ConjResidu( dn2(:,a,b,n), trD, hw1+hw2 )
      dn2=(0.d0,0.d0)

      beta(:,a,b,n)=const*matmul( dn2(:,a,b,n),D )*H**3

      write(*,'(3(/1x,"beta_",3i1," =",2g24.15))')
     &     1,a,b, real(beta(1,a,b,n)), imag(beta(1,a,b,n))
     &    ,2,a,b, real(beta(2,a,b,n)), imag(beta(2,a,b,n))
     &    ,3,a,b, real(beta(3,a,b,n)), imag(beta(3,a,b,n))

      h2(:,a,b,n)=(0.d0,0.d0)
      call Hartree(dn2(:,a,b,n),h2(:,a,b,n),Hconv)
      h2(:,a,b,n) = h2(:,a,b,n)
     &            + Fxc*dn2(:,a,b,n) + Gxc*dn1(:,a,n1)*dn1(:,b,n2)

      deallocate( trD, BB )

      return

      END SUBROUTINE calc_beta
