c=======================================================================
c============= First-order Independent-Particle Response Function (real)

      SUBROUTINE R_calc_chi1( trD, trH, hw1 )
      use lda_data
      use cg
      implicit none
      real(8),intent(OUT) :: trD(ML)
      real(8),intent(IN)  :: trH(ML)
      real(8),intent(IN)  :: hw1
      real(8),allocatable :: X0(:)
      integer             :: p

      trD=0.d0

      allocate( X0(ML) ) ; X0=0.d0

      do p=1,MST

         call ConjGrad( X0, psi(:,p)*trH, esp(p)+hw1 )

         trD=trD+occ(p)*psi(:,p)*X0

         call ConjGrad( X0, psi(:,p)*trH, esp(p)-hw1 )

         trD=trD+occ(p)*psi(:,p)*X0

      end do

      deallocate( X0 )

      return

      END SUBROUTINE R_calc_chi1

c=======================================================================
c========== First-order Independent-Particle Response Function (complex)

      SUBROUTINE C_calc_chi1( trD, trH, hw1 )
      use lda_data
      use cg
      implicit none
      complex(8),intent(OUT) :: trD(ML)
      complex(8),intent(IN)  :: trH(ML)
      complex(8),intent(IN)  :: hw1
      complex(8),allocatable :: X0(:)
      integer                :: p

      trD=(0.d0,0.d0)

      allocate( X0(ML) ) ; X0=(0.d0,0.d0)

      do p=1,MST

         call ConjGrad( X0, psi(:,p)*trH, esp(p)+hw1 )

         trD=trD+occ(p)*psi(:,p)*X0

         call ConjGrad( X0, psi(:,p)*conjg(trH), esp(p)-conjg(hw1) )

         trD=trD+occ(p)*psi(:,p)*conjg(X0)

      end do

      deallocate( X0 )

      return

      END SUBROUTINE C_calc_chi1
