
      MODULE chyp_data

      use lda_data
      use lda_interfaces
      use chyp_interfaces
      use cg

      implicit none

c Dipole Operator

      complex(8),allocatable :: D(:,:)

c Transition Densities

      complex(8),allocatable :: dn1(:,:,:)  ,h1(:,:,:)
      complex(8),allocatable :: dn2(:,:,:,:),h2(:,:,:,:)

c Hyperpolarizability tensors

      complex(8) :: alphaF(3,3,3)  ,alpha(3,3,3)
      complex(8) :: betaF(3,3,3,3) ,beta(3,3,3,3)
      complex(8) :: gammaF(3,3,3,3),gamma(3,3,3,3)

c Orientation averaged hyperpolarizabilities

      complex(8) :: alphaF_av(3), alpha_av(3)
      complex(8) :: betaF_av(3) , beta_av(3)
      complex(8) :: gammaF_av   , gamma_av

      complex(8) :: hw(3)
      real(8) :: const
      real(8) :: ep
      real(8) :: Hconv
      real(8),allocatable :: Fxc(:),Gxc(:),Hxc(:)

      integer :: Nrestart,Mrestart
      real(8) :: ep_rst

      CONTAINS

!=======================================================================

      SUBROUTINE OUT_hyp_data

      write(1) hw
      write(1) dn1,h1
      write(1) dn2,h2
      write(1) alphaF,alpha
      write(1) betaF,beta
      write(1) gammaF,gamma
      write(1) alphaF_av,alpha_av
      write(1) betaF_av,beta_av
      write(1) gammaF_av,gamma_av

      END SUBROUTINE OUT_hyp_data

!=======================================================================

      SUBROUTINE IN_hyp_data

      read(4) hw
      read(4) dn1,h1
      read(4) dn2,h2
      read(4) alphaF,alpha
      read(4) betaF,beta
      read(4) gammaF,gamma
      read(4) alphaF_av,alpha_av
      read(4) betaF_av,beta_av
      read(4) gammaF_av,gamma_av

      END SUBROUTINE IN_hyp_data

      END MODULE chyp_data
