c============================================ Second hyperpolarizability
c======================================== gamma_xabc(-w1-w2-w3;w1,w2,w3)

      SUBROUTINE calc_gamma( a,b,c, n1,n2,n3, n23,n31,n12, hw1,hw2,hw3 )
      use hyp_data
      implicit none

      integer,intent(IN)  :: a,b,c,n1,n2,n3,n23,n31,n12
      real(8),intent(IN)  :: hw1,hw2,hw3

      real(8),allocatable :: trD(:),BB(:)
      real(8),allocatable :: v1(:),v2(:),v3(:)
      real(8),allocatable :: tF(:),tG(:),tH(:)

      write(*,'(/1x,"----- gamma_x",3i1," -----")') a,b,c

      allocate( v1(ML),v2(ML),v3(ML),trD(ML) )
      allocate( tF(ML),tG(ML),tH(ML), BB(ML) )

! gamma ( free )

      write(*,'(/1x,"(Free)")')

      iterCG=0

c chi1

      tH = Hxc*dn1(:,a,n1)*dn1(:,b,n2)*dn1(:,c,n3)
     &   + Gxc*( dn1(:,a,n1)*dn2(:,b,c,n23)
     &          +dn1(:,b,n2)*dn2(:,c,a,n31)
     &          +dn1(:,c,n3)*dn2(:,a,b,n12) )

      call calc_chi1( trD, tH, hw1+hw2+hw3 )

c chi2

      call calc_chi2( v1, h1(:,a,n1),h2(:,b,c,n23), hw1,hw2+hw3 )
      call calc_chi2( BB, h2(:,b,c,n23),h1(:,a,n1), hw2+hw3,hw1 )
      v1=v1+BB

      if ( b==a .and. n2==n1 ) then
         v2=v1
      else
         call calc_chi2( v2, h1(:,b,n2),h2(:,c,a,n31), hw2,hw3+hw1 )
         call calc_chi2( BB, h2(:,c,a,n31),h1(:,b,n2), hw3+hw1,hw2 )
         v2=v2+BB
      end if

      if ( c==a .and. n3==n1 ) then
         v3=v1
      else if ( c==b .and. n3==n2 ) then
         v3=v2
      else
         call calc_chi2( v3, h1(:,c,n3),h2(:,a,b,n12), hw3,hw1+hw2 )
         call calc_chi2( BB, h2(:,a,b,n12),h1(:,c,n3), hw1+hw2,hw3 )
         v3=v3+BB
      end if

      trD=trD+v1+v2+v3

c chi3

      tF=h1(:,a,n1) ; tG=h1(:,b,n2) ; tH=h1(:,c,n3)

      call calc_chi3( v1, tF,tG,tH, hw1,hw2,hw3 )

      if ( a==b .and. b==c .and. n1==n2 .and. n2==n3 ) then
         v1=6*v1
      else if ( b==c .and. n2==n3 ) then
         call calc_chi3( BB, tG,tF,tG, hw2,hw1,hw2 ) ; v1=v1+BB
         call calc_chi3( BB, tG,tG,tF, hw2,hw2,hw1 ) ; v1=v1+BB
         v1=2*v1
      else if ( c==a .and. n3==n1 ) then
         call calc_chi3( BB, tH,tH,tG, hw3,hw3,hw2 ) ; v1=v1+BB
         call calc_chi3( BB, tG,tH,tH, hw2,hw3,hw3 ) ; v1=v1+BB
         v1=2*v1
      else if ( a==b .and. n1==n2 ) then
         call calc_chi3( BB, tF,tH,tF, hw1,hw3,hw1 ) ; v1=v1+BB
         call calc_chi3( BB, tH,tF,tF, hw3,hw1,hw1 ) ; v1=v1+BB
         v1=2*v1
      else
         call calc_chi3( BB, tF,tH,tG, hw1,hw3,hw2 ) ; v1=v1+BB
         call calc_chi3( BB, tG,tF,tH, hw2,hw1,hw3 ) ; v1=v1+BB
         call calc_chi3( BB, tG,tH,tF, hw2,hw3,hw1 ) ; v1=v1+BB
         call calc_chi3( BB, tH,tF,tG, hw3,hw1,hw2 ) ; v1=v1+BB
         call calc_chi3( BB, tH,tG,tF, hw3,hw2,hw1 ) ; v1=v1+BB
      end if

      trD=trD+v1

      gammaF(:,a,b,c) = const*matmul( trD, D )*H**3

      write(*,'(3(/1x,"gammaF_",4i1," =",g24.15))')
     &     1,a,b,c, gammaF(1,a,b,c)
     &    ,2,a,b,c, gammaF(2,a,b,c)
     &    ,3,a,b,c, gammaF(3,a,b,c)

      write(*,'(/1x,"C-G iteration =",i5)') iterCG

      deallocate( v1,v2,v3,tF,tG,tH )

! gamma

      write(*,'(/1x,"(RPA)")')

      BB=trD ; trD=0.d0
!              trD=BB

      call ConjResidu( trD, BB, hw1+hw2+hw3 )

      gamma(:,a,b,c) = const*matmul( trD, D )*H**3

      write(*,'(3(/1x,"gamma_",4i1," =",g24.15))')
     &     1,a,b,c, gamma(1,a,b,c)
     &    ,2,a,b,c, gamma(2,a,b,c)
     &    ,3,a,b,c, gamma(3,a,b,c)

      deallocate( trD,BB )

      return

      END SUBROUTINE calc_gamma
