
      MODULE hyp_interfaces

      implicit none

      INTERFACE

!         SUBROUTINE ConjGrad( Xn, B0, E, CG_Solver, iterCG )
!         use lda_data
!         implicit none
!         real(8),intent(OUT)            :: Xn(ML)
!         real(8),intent(IN)             :: B0(ML)
!         real(8),intent(IN)             :: E
!         character(6),intent(IN)        :: CG_Solver
!         integer,intent(INOUT),optional :: iterCG
!         END SUBROUTINE ConjGrad

         SUBROUTINE calc_alpha(n,a,hw1)
         implicit none
         integer,intent(IN)  :: n,a
         real(8),intent(IN)  :: hw1
         END SUBROUTINE calc_alpha

         SUBROUTINE calc_beta( n, a,b, n1,n2, hw1,hw2 )
         implicit none
         integer,intent(IN)  :: n,a,b,n1,n2
         real(8),intent(IN)  :: hw1,hw2
         END SUBROUTINE calc_beta

         SUBROUTINE calc_gamma( a,b,c,n1,n2,n3,n23,n31,n12,hw1,hw2,hw3 )
         implicit none
         integer,intent(IN)  :: a,b,c,n1,n2,n3,n23,n31,n12
         real(8),intent(IN)  :: hw1,hw2,hw3
         END SUBROUTINE calc_gamma

         SUBROUTINE ConjResidu( Xn, B, hw1 )
         use lda_data
         implicit none
         real(8),intent(INOUT) :: Xn(ML)
         real(8),intent(IN)    :: B(ML),hw1
         END SUBROUTINE ConjResidu

      END INTERFACE

      INTERFACE calc_chi1
         SUBROUTINE R_calc_chi1( trD, trH, hw1 )
         use lda_data
         implicit none
         real(8),intent(OUT) :: trD(ML)
         real(8),intent(IN)  :: trH(ML)
         real(8),intent(IN)  :: hw1
         END SUBROUTINE R_calc_chi1
         SUBROUTINE C_calc_chi1( trD, trH, hw1 )
         use lda_data
         implicit none
         complex(8),intent(OUT) :: trD(ML)
         complex(8),intent(IN)  :: trH(ML)
         real(8),intent(IN)  :: hw1
         END SUBROUTINE C_calc_chi1
      END INTERFACE

      INTERFACE calc_chi2
         SUBROUTINE R_calc_chi2( trD, tH1,tH2, hw1,hw2 )
         use lda_data
         implicit none
         real(8),intent(OUT) :: trD(ML)
         real(8),intent(IN)  :: tH1(ML),tH2(ML)
         real(8),intent(IN)  :: hw1,hw2
         END SUBROUTINE R_calc_chi2
         SUBROUTINE C_calc_chi2( trD, tH1,tH2, hw1,hw2 )
         use lda_data
         implicit none
         complex(8),intent(OUT) :: trD(ML)
         complex(8),intent(IN)  :: tH1(ML),tH2(ML)
         real(8),intent(IN)  :: hw1,hw2
         END SUBROUTINE C_calc_chi2
      END INTERFACE

      INTERFACE calc_chi3
         SUBROUTINE R_calc_chi3( trD, tH1,tH2,tH3, hw1,hw2,hw3 )
         use lda_data
         implicit none
         real(8),intent(OUT) :: trD(ML)
         real(8),intent(IN)  :: tH1(ML),tH2(ML),tH3(ML)
         real(8),intent(IN)  :: hw1,hw2,hw3
         END SUBROUTINE R_calc_chi3
         SUBROUTINE C_calc_chi3( trD, tH1,tH2,tH3, hw1,hw2,hw3 )
         use lda_data
         implicit none
         complex(8),intent(OUT) :: trD(ML)
         complex(8),intent(IN)  :: tH1(ML),tH2(ML),tH3(ML)
         real(8),intent(IN)  :: hw1,hw2,hw3
         END SUBROUTINE C_calc_chi3
      END INTERFACE

      END MODULE hyp_interfaces
