!=======================================================================
!================================================= Initial wave function

      SUBROUTINE init_wf(wf1,wf2)
      use lda_data
      implicit none
      real(8),intent(OUT) :: wf1(ML,MST),wf2(ML,MST)
      optional            :: wf2

      integer :: i,p,a
      real(8) :: x,y,z,x1,y1,z1,r,rnd,Xmax,Ymax,Zmax

      Xmax=0.d0 ; Ymax=0.d0 ; Zmax=0.d0
      do a=1,MI
         if ( abs(Rion(1,a)) > Xmax ) Xmax=abs(Rion(1,a))
         if ( abs(Rion(2,a)) > Ymax ) Ymax=abs(Rion(2,a))
         if ( abs(Rion(3,a)) > Zmax ) Zmax=abs(Rion(3,a))
      end do
      Xmax=Xmax+1.d0 ; Ymax=Ymax+1.d0 ; Zmax=Zmax+1.d0

      do p=1,MST
         call random_number(rnd) ; x1=Xmax*(2*rnd-1)
         call random_number(rnd) ; y1=Ymax*(2*rnd-1)
         call random_number(rnd) ; z1=Zmax*(2*rnd-1)
         do i=1,ML
            x=Lx(i)*H-x1 ; y=Ly(i)*H-y1 ; z=Lz(i)*H-z1
            r=sqrt(x*x+y*y+z*z) ; wf1(i,p)=exp(-0.5d0*r**2)
         end do
      end do

      if ( .not.present(wf2) ) return

      do p=1,MST
         call random_number(rnd) ; x1=Xmax*(2*rnd-1)
         call random_number(rnd) ; y1=Ymax*(2*rnd-1)
         call random_number(rnd) ; z1=Zmax*(2*rnd-1)
         do i=1,ML
            x=Lx(i)*H-x1 ; y=Ly(i)*H-y1 ; z=Lz(i)*H-z1
            r=sqrt(x*x+y*y+z*z) ; wf2(i,p)=exp(-0.5d0*r**2)
         end do
      end do

      return

      END SUBROUTINE init_wf
