
      MODULE lda_interfaces
      implicit none

      INTERFACE

         SUBROUTINE watch(ctime,dctime,etime,detime,DISP)
         implicit none
         character(5),intent(IN) ,optional :: DISP
         real(8)     ,intent(OUT),optional :: ctime,dctime,etime,detime
         END SUBROUTINE watch

         SUBROUTINE init_mesh
         implicit none
         END SUBROUTINE init_mesh

         SUBROUTINE init_ps
         implicit none
         END SUBROUTINE init_ps

         SUBROUTINE init_wf(wf1,wf2)
         use lda_data
         implicit none
         real(8),intent(OUT) :: wf1(ML,MST),wf2(ML,MST)
         optional            :: wf2
         END SUBROUTINE init_wf

         SUBROUTINE Exc_Cor(XC_in,Exc)
         implicit none
         character(4),intent(IN)           :: XC_in
         real(8)     ,intent(OUT),optional :: Exc
         END SUBROUTINE Exc_Cor

         SUBROUTINE Exc_Cor_Kernel(XC_in,Fxc,Gxc,Hxc)
         use lda_data
         implicit none
         character(4),intent(IN) :: XC_in
         real(8),intent(OUT)     :: Fxc(ML),Gxc(ML),Hxc(ML)
         optional                :: Gxc,Hxc
         END SUBROUTINE Exc_Cor_Kernel

      END INTERFACE


      INTERFACE hpsi
         SUBROUTINE R_hpsi(tpsi,htpsi)
         use lda_data
         implicit none
         real(8),intent(IN)  :: tpsi(ML)
         real(8),intent(OUT) :: htpsi(ML)
         END SUBROUTINE R_hpsi
         SUBROUTINE C_hpsi(tpsi,htpsi)
         use lda_data
         implicit none
         complex(8),intent(IN)  :: tpsi(ML)
         complex(8),intent(OUT) :: htpsi(ML)
         END SUBROUTINE C_hpsi
      END INTERFACE

      INTERFACE Hartree
         SUBROUTINE R_Hartree(trho,tVh,Hconv,iterVh)
         use lda_data
         implicit none
         real(8),intent(IN)           :: trho(ML)
         real(8),intent(INOUT)        :: tVh(ML)
         real(8),intent(IN),optional  :: Hconv
         integer,intent(OUT),optional :: iterVh
         END SUBROUTINE R_Hartree
         SUBROUTINE C_Hartree(trho,tVh,Hconv,iterVh)
         use lda_data
         implicit none
         complex(8),intent(IN)           :: trho(ML)
         complex(8),intent(INOUT)        :: tVh(ML)
         real(8),intent(IN),optional     :: Hconv
         integer,intent(OUT),optional    :: iterVh
         END SUBROUTINE C_Hartree
      END INTERFACE

      END MODULE lda_interfaces
