c=======================================================================
c=========================================== Spherical harmonic function

      FUNCTION Ylm(x,y,z,lm)
      implicit none
      real(8) :: Ylm
      real(8),intent(IN) :: x,y,z
      integer,intent(IN) :: lm

      real(8) :: rrrr

      select case( lm )

      case(1)  ; Ylm=1.d0
      case(2)  ; Ylm=y
      case(3)  ; Ylm=z
      case(4)  ; Ylm=x
      case(5)  ; Ylm=sqrt(3.d0)*x*y                     ! lm=5  (2 -2)
      case(6)  ; Ylm=sqrt(3.d0)*y*z                     ! lm=6  (2 -1)
      case(7)  ; Ylm=(2*z*z-x*x-y*y)/2.d0               ! lm=7  (2 0)
      case(8)  ; Ylm=sqrt(3.d0)*x*z                     ! lm=8  (2 1)
      case(9)  ; Ylm=sqrt(3.d0/4.d0)*(x*x-y*y)          ! lm=9  (2 2)
      case(10) ; Ylm=sqrt(5.d0/8.d0)*y*(3*x*x-y*y)      ! lm=10 (3 -3)
      case(11) ; Ylm=sqrt(15.d0)*x*y*z                  ! lm=11 (3 -2)
      case(12) ; Ylm=sqrt(3.d0/8.d0)*y*(4*z*z-x*x-y*y)  ! lm=12 (3 -1)
      case(13) ; Ylm=z*(2*z*z-3*x*x-3*y*y)/2.d0         ! lm=13 (3 0)
      case(14) ; Ylm=sqrt(3.d0/8.d0)*x*(4*z*z-x*x-y*y)  ! lm=14 (3 1)
      case(15) ; Ylm=sqrt(15.d0/4.d0)*z*(x*x-y*y)       ! lm=15 (3 2)
      case(16) ; Ylm=sqrt(5.d0/8.d0)*x*(x*x-3*y*y)      ! lm=16 (3 3)

! for Hartree routine         

      case(17)
         rrrr=(x**2+y**2+z**2)**2
         Ylm=rrrr*sqrt(35.d0)/2.d0*x*y*(x**2-y**2)
      case(18)
         rrrr=(x**2+y**2+z**2)**2
         Ylm=rrrr*sqrt(35.d0/8.d0)*y*z*(3*x**2-y**2)
      case(19)
         rrrr=(x**2+y**2+z**2)**2
         Ylm=rrrr*sqrt(5.d0)/2.d0*x*y*(7*z**2-1)
      case(20)
         rrrr=(x**2+y**2+z**2)**2
         Ylm=rrrr*sqrt(5.d0/8.d0)*y*(7*z**3-3*z)
      case(21)
         rrrr=(x**2+y**2+z**2)**2
         Ylm=rrrr*(35*z**4-30*z**2+3.d0)/8.d0
      case(22)
         rrrr=(x**2+y**2+z**2)**2
         Ylm=rrrr*sqrt(5.d0/8.d0)*x*(7*z**3-3*z)
      case(23)
         rrrr=(x**2+y**2+z**2)**2
         Ylm=rrrr*sqrt(5.d0)/4.d0*(7*z**2-1)*(x**2-y**2)
      case(24)
         rrrr=(x**2+y**2+z**2)**2
         Ylm=rrrr*sqrt(35.d0/8.d0)*z*x*(x**2-3*y**2)
      case(25)
         rrrr=(x**2+y**2+z**2)**2
         Ylm=rrrr*sqrt(35.d0)/8.d0*(x**4+y**4-6*x**2*y**2)

      end select

      END FUNCTION Ylm
